Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
Halide::Internal::BufferBuilder Struct Reference

A builder to help create Exprs representing halide_buffer_t structs (e.g. More...

`#include <IROperator.h>`

## Public Member Functions
Expr | build () const

## Public Attributes
Expr | buffer_memory
Expr | shape_memory
Expr | host
Expr | device
Expr | device_interface
Type | type
int | dimensions = 0
std::vector< Expr > | mins
std::vector< Expr > | extents
std::vector< Expr > | strides
Expr | host_dirty
Expr | device_dirty

## Detailed Description

A builder to help create Exprs representing halide_buffer_t structs (e.g.

foo.buffer) via calls to halide_buffer_init. Fill out the fields and then call build. The resulting Expr will be a call to halide_buffer_init with the struct members as arguments. If the buffer_memory field is undefined, it uses a call to alloca to make some stack memory for the buffer. If the shape_memory field is undefined, it similarly uses stack memory for the shape. If the shape_memory field is null, it uses the dim field already in the buffer. Other unitialized fields will take on a value of zero in the constructed buffer.

Definition at line 228 of file IROperator.h.

## Member Function Documentation

## ◆ build()

Expr Halide::Internal::BufferBuilder::build | ( |  | ) | const

## Member Data Documentation

## ◆ buffer_memory

Expr Halide::Internal::BufferBuilder::buffer_memory

Definition at line 229 of file IROperator.h.

## ◆ shape_memory

Expr Halide::Internal::BufferBuilder::shape_memory

Definition at line 229 of file IROperator.h.

## ◆ host

Expr Halide::Internal::BufferBuilder::host

Definition at line 230 of file IROperator.h.

## ◆ device

Expr Halide::Internal::BufferBuilder::device

Definition at line 230 of file IROperator.h.

## ◆ device_interface

Expr Halide::Internal::BufferBuilder::device_interface

Definition at line 230 of file IROperator.h.

## ◆ type

Type Halide::Internal::BufferBuilder::type

Definition at line 231 of file IROperator.h.

## ◆ dimensions

int Halide::Internal::BufferBuilder::dimensions = 0

Definition at line 232 of file IROperator.h.

## ◆ mins

std::vector<Expr> Halide::Internal::BufferBuilder::mins

Definition at line 233 of file IROperator.h.

## ◆ extents

std::vector<Expr> Halide::Internal::BufferBuilder::extents

Definition at line 233 of file IROperator.h.

## ◆ strides

std::vector<Expr> Halide::Internal::BufferBuilder::strides

Definition at line 233 of file IROperator.h.

## ◆ host_dirty

Expr Halide::Internal::BufferBuilder::host_dirty

Definition at line 234 of file IROperator.h.

## ◆ device_dirty

Expr Halide::Internal::BufferBuilder::device_dirty

Definition at line 234 of file IROperator.h.

The documentation for this struct was generated from the following file:

- src/IROperator.h